/***
 * filter.java,v 1.1 1997/12/30 22:06:27
 *
 * This is a sample program demonstrating how to use the regular expression
 * filename filter classes.
 *
 * Copyright 1997 Original Reusable Objects, Inc.  All rights reserved.
 ***/

import java.io.*;
import java.util.*;

import com.oroinc.io.*;
import com.oroinc.text.*;

public final class filter {

  public static void printList(String[] list) {
    System.out.println();
    for(int i=0; i < list.length; i++)
      System.out.println(list[i]);
    System.out.println();
  }

  public static final void main(String[] args) {
    File dir;
    FilenameFilter filter;
    String[] list;

    dir = new File(System.getProperty("user.dir"));

    // List all files ending in .java
    filter = new GlobFilenameFilter("*.java",
			    GlobCompiler.STAR_CANNOT_MATCH_NULL_MASK);
    System.out.println("Glob: *.java");
    printList(dir.list(filter));

    // List all files ending in .class
    filter = new AwkFilenameFilter(".+\\.class");
    System.out.println("Awk: .+\\.class");
    printList(dir.list(filter));

    // List all files ending in .java or .class
    filter = new Perl5FilenameFilter(".+\\.(?:java|class)");
    System.out.println("Perl5: .+\\.(?:java|class)");
    printList(dir.list(filter));
  }

}
