/***
 * semicolon.java,v 1.3 1997/12/29 21:12:32 
 *
 * This is a simple example program showing how to use the MatchActionProcessor
 * class.  It reads the provided semi-colon delimited file semicolon.txt and
 * outputs only the second column to standard output.
 *
 * Copyright 1997 Original Reusable Objects, Inc.  All rights reserved.
 ***/

import java.io.*;

import com.oroinc.text.*;
import com.oroinc.text.regex.*;

public final class semicolon {

  public static final void main(String[] args) {
    MatchActionProcessor processor = new MatchActionProcessor();

    try {
      processor.setFieldSeparator(";");
      // Using a null pattern means to perform the action for every line.
      processor.addAction(null, new MatchAction() {
	public void processMatch(MatchActionInfo info) {
	  // We assume the second column exists
	  info.output.println(info.fields.elementAt(1));
	}
      });
    } catch(MalformedPatternException e) {
      e.printStackTrace();
      System.exit(1);
    }

    try {
      processor.processMatches(new FileInputStream("semicolon.txt"),
			       System.out);
    } catch(IOException e) {
      e.printStackTrace();
      System.exit(1);
    }
  }

}
